regina::Manifold Class Referenceabstract
Standard 3-Manifolds

Represents a particular 3-manifold. More...

`#include <manifold/manifold.h>`

Inheritance diagram for regina::Manifold:

## Public Member Functions

virtual | ~Manifold ()
| A destructor that does nothing. More...
std::string | name () const
| Returns the common name of this 3-manifold as a human-readable string. More...
std::string | TeXName () const
| Returns the common name of this 3-manifold in TeX format. More...
std::string | structure () const
| Returns details of the structure of this 3-manifold that might not be evident from its common name. More...
virtual Triangulation< 3 > * | construct () const
| Returns a triangulation of this 3-manifold, if such a construction has been implemented. More...
virtual AbelianGroup * | homology () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
AbelianGroup * | homologyH1 () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
virtual bool | isHyperbolic () const =0
| Returns whether or not this is a finite-volume hyperbolic manifold. More...
bool | operator< (const Manifold &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold. More...
virtual std::ostream & | writeName (std::ostream &out) const =0
| Writes the common name of this 3-manifold as a human-readable string to the given output stream. More...
virtual std::ostream & | writeTeXName (std::ostream &out) const =0
| Writes the common name of this 3-manifold in TeX format to the given output stream. More...
virtual std::ostream & | writeStructure (std::ostream &out) const
| Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream. More...
void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Detailed Description

Represents a particular 3-manifold.

The triangulation of this 3-manifold that may be in use is not of interest.

Subclasses corresponding to the different types of 3-manifold must (of course) override all pure virtual functions. They must not override writeTextShort() or writeTextLong(), since these routines are not virtual, and are provided by the base class Manifold.

## Constructor & Destructor Documentation

## ~Manifold()

regina::Manifold::~Manifold | ( |  | ) |

inline virtual

A destructor that does nothing.

## Member Function Documentation

## construct()

Triangulation< 3 > * regina::Manifold::construct | ( |  | ) | const

inline virtual

Returns a triangulation of this 3-manifold, if such a construction has been implemented.

If no construction routine has yet been implemented for this 3-manifold (for instance, if this 3-manifold is a Seifert fibred space with sufficiently many exceptional fibres) then this routine will return 0.

The details of which 3-manifolds have construction routines can be found in the notes for the corresponding subclasses of Manifold. The default implemention of this routine returns 0.

Returns
  a triangulation of this 3-manifold, or 0 if the appropriate construction routine has not yet been implemented.

Reimplemented in regina::SFSpace, regina::SnapPeaCensusManifold, regina::LensSpace, and regina::SimpleSurfaceBundle.

## detail()

std::string regina::Output< Manifold , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## homology()

AbelianGroup * regina::Manifold::homology | ( |  | ) | const

inline virtual

Returns the first homology group of this 3-manifold, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this 3-manifold then this routine will return 0.

The details of which 3-manifolds have homology calculation routines can be found in the notes for the corresponding subclasses of Manifold. The default implemention of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

This routine can also be accessed via the alias homologyH1() (a name that is more specific, but a little longer to type).

Returns
  the first homology group of this 3-manifold, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented in regina::SFSpace, regina::GraphTriple, regina::GraphPair, regina::GraphLoop, regina::SnapPeaCensusManifold, regina::TorusBundle, regina::LensSpace, regina::SimpleSurfaceBundle, and regina::Handlebody.

## homologyH1()

AbelianGroup * regina::Manifold::homologyH1 | ( |  | ) | const

inline

Returns the first homology group of this 3-manifold, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this 3-manifold then this routine will return 0.

The details of which 3-manifolds have homology calculation routines can be found in the notes for the corresponding subclasses of Manifold. The default implemention of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

This routine can also be accessed via the alias homology() (a name that is less specific, but a little easier to type).

Returns
  the first homology group of this 3-manifold, or 0 if the appropriate calculation routine has not yet been implemented.

## isHyperbolic()

virtual bool regina::Manifold::isHyperbolic | ( |  | ) | const

pure virtual

Returns whether or not this is a finite-volume hyperbolic manifold.

Returns
  `true` if this is a finite-volume hyperbolic manifold, or `false` if not.

Implemented in regina::SFSpace, regina::GraphTriple, regina::GraphPair, regina::GraphLoop, regina::SnapPeaCensusManifold, regina::TorusBundle, regina::LensSpace, regina::SimpleSurfaceBundle, and regina::Handlebody.

## name()

std::string regina::Manifold::name | ( |  | ) | const

Returns the common name of this 3-manifold as a human-readable string.

Returns
  the common name of this 3-manifold.

## operator<()

bool regina::Manifold::operator< | ( | const Manifold & | compare | ) | const

Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold.

The ordering imposed on 3-manifolds is purely aesthetic on the part of the author, and is subject to change in future versions of Regina.

The ordering also depends on the particular representation of the 3-manifold that is used. As an example, different representations of the same Seifert fibred space might well be ordered differently.

All that this routine really offers is a well-defined way of ordering 3-manifold representations.

Warning
  Currently this routine is only implemented in full for closed 3-manifolds. For most classes of bounded 3-manifolds, this routine simply compares the strings returned by name().

Parameters

  compare | the 3-manifold representation with which this will be compared.

Returns
  `true` if and only if this is "smaller" than the given 3-manifold representation.

## str()

std::string regina::Output< Manifold , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:
  In addition to str(), this is also used as the Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## structure()

std::string regina::Manifold::structure | ( |  | ) | const

Returns details of the structure of this 3-manifold that might not be evident from its common name.

For instance, for an orbit space S^3/G this routine might return the full Seifert structure.

This routine may return the empty string if no additional details are deemed necessary.

Returns
  a string describing additional structural details.

## TeXName()

std::string regina::Manifold::TeXName | ( |  | ) | const

Returns the common name of this 3-manifold in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the common name of this 3-manifold in TeX format.

## utf8()

std::string regina::Output< Manifold , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## writeName()

virtual std::ostream& regina::Manifold::writeName | ( | std::ostream & | out | ) | const

pure virtual

Writes the common name of this 3-manifold as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; instead standard output will always be used. Moreover, this routine returns `None`.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implemented in regina::SFSpace, regina::GraphTriple, regina::GraphPair, regina::GraphLoop, regina::SnapPeaCensusManifold, regina::TorusBundle, regina::LensSpace, regina::SimpleSurfaceBundle, and regina::Handlebody.

## writeStructure()

std::ostream & regina::Manifold::writeStructure | ( | std::ostream & | out | ) | const

inline virtual

Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream.

For instance, for an orbit space S^3/G this routine might write the full Seifert structure.

This routine may write nothing if no additional details are deemed necessary. The default implementation of this routine behaves in this way.

Python:
  The parameter out does not exist; instead standard output will always be used. Moreover, this routine returns `None`.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Reimplemented in regina::SFSpace, and regina::SnapPeaCensusManifold.

## writeTeXName()

virtual std::ostream& regina::Manifold::writeTeXName | ( | std::ostream & | out | ) | const

pure virtual

Writes the common name of this 3-manifold in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; instead standard output will always be used. Moreover, this routine returns `None`.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implemented in regina::SFSpace, regina::GraphTriple, regina::GraphPair, regina::GraphLoop, regina::SnapPeaCensusManifold, regina::TorusBundle, regina::LensSpace, regina::SimpleSurfaceBundle, and regina::Handlebody.

## writeTextLong()

void regina::Manifold::writeTextLong | ( | std::ostream & | out | ) | const

inline

Writes a detailed text representation of this object to the given output stream.

Subclasses must not override this routine. They should override writeName() and writeStructure() instead.

Python:
  Not present.

Parameters

  out | the output stream to which to write.

## writeTextShort()

void regina::Manifold::writeTextShort | ( | std::ostream & | out | ) | const

inline

Writes a short text representation of this object to the given output stream.

Subclasses must not override this routine. They should override writeName() instead.

Python:
  Not present.

Parameters

  out | the output stream to which to write.

The documentation for this class was generated from the following file:

- manifold/manifold.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).